;Acts as $25

;What type of condition of beating a level, 0 = current translevel (the first level
;entered from the map), 1 = if a specific level is beaten somewhere.
!CertainLvl	= 0

!freeram_count  = $0F42|!addr

;What level will make this door enabled or disabled (not used if above setting = 0)
;ONLY use values $000~$024 OR $101~$13B.
!WhatLvl	= $105

;Reverse flag, 0 = require completion, 1 = prohibit completion:
!Reverse	= 0

;Don't touch these

if !WhatLvl > $24
	!TransLvlNum = !WhatLvl-$DC
else
	!TransLvlNum = !WhatLvl
endif

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP SpriteV : JMP SpriteH
JMP MarioCape : JMP MarioFireBall : JMP TopCorner : JMP HeadInside : JMP BodyInside

BodyInside:
MarioAbove:
MarioBelow:
MarioSide:
TopCorner:			;\This must be included so that the centercheck works on big mario
HeadInside:			;/also.
	LDA $16				;\If not pressing up, return
	AND.b #%00001000		;|
	BEQ Return			;/

	REP #$20			;\if mario is 4 pixels far to the left or further
	LDA $9A				;|or 3 pixels far to the right or further,
	AND #$FFF0			;|then return (this was used on the origional
	SEC : SBC #$0005		;|smw's door to prevent mario from entering from
	CMP $94				;|the very edge)
	BCS return_16bit		;|
	CLC : ADC #$0008		;|
	CMP $94				;|
	BCC return_16bit		;|
	SEP #$20			;/
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Feel free to use this small routine to check if the current level
;is beaten or not.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	if !CertainLvl == 0
		LDX $13BF			;>Load index for translevel number (LM levels $025 to $100 excluded)
		LDA $1EA2,x			;>Load current level status that the player has entered (excludes $025 to $100)
		if !Reverse == 0
			BPL IncorrectSfx	;>If NOT beaten, return with nothing happening
		else
			BMI IncorrectSfx	;>If beaten, return with nothing happening
		endif
	else
		LDA.w $1EA2+!TransLvlNum	;>Load level status.
		if !Reverse == 0
			BPL IncorrectSfx	;>If NOT beaten, return with nothing happening
		else
			BMI IncorrectSfx	;>If beaten, return with nothing happening
		endif
	endif
        LDA !freeram_count
        BNE IncorrectSfx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Entering a door:
	REP #$20		;\Center the player into the door.
	LDA $9A			;|(Although, this is needed if you place this next to and to
	AND #$FFF0		;|the right of the subscreen boundary and enter the door left
	STA $94			;|of it.
	LDA $98			;|
	AND #$FFF0		;|
	SEC			;|
	SBC #$0010		;|
	STA $96			;|
	SEP #$20		;/
	STZ $7B			;\Just in case if the blocks centers the player AND THEN
	STZ $7D			;/his positions gets updated by $00DC2D afterwards.

	LDA #$0F			;\Door sfx
	STA $1DFC			;/
	LDA #$06			;\
	STA $71				;| Teleport the player via screen exit.
	STZ $88				;|
	STZ $89				;/
Return:
	RTL

IncorrectSfx:
	LDA #$2A		;\Play sfx.
	STA $1DFC		;/
SpriteV:
SpriteH:
MarioCape:
MarioFireBall:

return_16bit:
	SEP #$20
	RTL

if !CertainLvl == 0
	if !Reverse == 0
		Print "Acts as a door if the current level is beaten."
	else
		Print "Acts as a door if the current level isn't beaten."
	endif
else
	if !Reverse == 0
		Print "Acts as a door if level !WhatLvl is beaten"
	else
		Print "Acts as a door if level !WhatLvl isn't beaten"
	endif
endif